'-------------------------------------------------------------------
' iButton Identifikation
'-------------------------------------------------------------------
$regfile = "m8def.dat"                                      ' ATmega8
$crystal = 3686400                                          ' fr STK500
$baud = 9600

Config 1wire = Portb.0                                      ' PB0 ist 1-Wire Busleitung

Dim Rom_data(8) As Byte
Dim I As Byte , W As Word

Declare Sub Crc8_check()

Do
   Print
   Print "Suche nach iButtons..."
   Print
   Rom_data(1) = 1wsearchfirst()                            ' Suche nach erstem iButton
   If Err = 1 Then Goto Cnt                                 ' kein iButton vorhanden
   For I = 1 To 8
      Print Hex(rom_data(i));                               ' Ausgabe der ROM Daten
   Next
   Crc8_check                                               ' berprfung CRC-8
   Print
   Do
      Rom_data(1) = 1wsearchnext()                          ' Suche nach weiteren iButtons
      If Err = 1 Then Exit Do                               ' kein weiterer iButton vorhanden
      For I = 1 To 8
         Print Hex(rom_data(i));                            ' Ausgabe der ROM Daten
      Next
      Crc8_check                                            ' berprfung CRC-8
      Print
   Loop
Cnt:
   W = 1wirecount()
   Print
   Print "Anzahl der iButtons am 1-Wire Bus ist " ; W
   Print "---------------------------------------";
   Wait 2
Loop

End

Sub Crc8_check()
   $external _crc8
   Local Result As Byte
   Loadadr Rom_data(1) , Z
   ldi R24, 8
   !Call _crc8
   Loadadr Result , X
   st X, R16
   If Result = 0 Then
      Print " CRC-8 OK";
   Else
      Print " CRC-8 ERROR";
   End If
End Sub