'--------------------------------------------------------------------------------------
'name                     : HelloButterfly.bas
'programmed by            : Claus Kuhnel
'date                     : 2008-07-14
'purpose                  : Test LCD on AVR Butterfly
'micro                    : ATmega169
'tested with              : V.1.11.9.8
'suited for demo          : yes
'commercial addon needed  : no
'--------------------------------------------------------------------------------------
$regfile = "m169def.dat"                                    ' specify the used micro
$crystal = 8000000                                          ' used crystal frequency
$baud = 19200                                               ' used baud rate

$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space

$lib "lcd_butterfly.lbx"

Debug Off                                                   ' set debug on for UART output

'Butterfly LCD Setup:
Dim _butterfly_digit As Byte

Dim S As String * 9
Dim Sd As String * 6
Dim I As Byte

'Butterfly LCD Test:
S = "BUTTERFLY"                                             ' display string for LCD output

Do
   Cls
   Lcd "HELLO"
   Debug "HELLO"
   Waitms 500
   For I = 1 To 4
      Sd = Mid(s , I , 6)                                   ' cut six characters from display string
      Cls
      Lcd Sd
      Debug Sd
      Waitms 150
   Next
Loop

End

Lcd_butterfly_data:
Data 0%                                                     ' space
Data 0%                                                     ' !
Data 0%                                                     ' "
Data 0%                                                     ' #
Data 0%                                                     ' $
Data 0%                                                     ' %
Data 0%                                                     ' &
Data 0%                                                     ' '
Data 0%                                                     ' (
Data 0%                                                     ' )
Data &HEAA8%                                                ' *
Data &H2A80%                                                ' +
Data 0%                                                     ' ,
Data &H0A00%             ' -
Data &H8000%                                                ' .
Data 0%                                                     ' /
Data &H5559%                                                ' 0
Data &H0118%                                                ' 1
Data &H1E11%                                                ' 2
Data &H1B11%                                                ' 3
Data &H0B50%                                                ' 4
Data &H1B41%                                                ' 5
Data &H1F41%                                                ' 6
Data &H0111%                                                ' 7
Data &H1F51%                                                ' 8
Data &H1B51%                                                ' 9
Data 0%                                                     ' :
Data 0%                                                     ' ;
Data 0%                                                     ' <
Data 0%                                                     ' =
Data 0%                                                     ' >
Data 0%                                                     ' ?
Data 0%                                                     ' @
Data &H0F51%                                                ' A
Data &H3991% , &H1441% , &H3191% , &H1E41% , &H0E41% , &H1D41% , &H0F50% , &H2080% , &H1510% , &H8648% , &H1440% , &H0578%
Data &H8570% , &H1551% , &H0E51% , &H9551% , &H8E51% , &H9021% , &H2081% , &H1550% , &H4448% , &HC550% , &HC028% , &H2028% , &H5009%
