$regfile = "m8def.dat"                  ' ATmega8
$crystal = 3690000                      ' fr STK500
$baud = 19200

' HW Stack 40; Soft Stack 20; Frame Size 40   nicht optimiert

Const Device_id = &HA                   ' Device ID fr EEPROM NM24Cxx
Const Page_addr = 1                     ' verwendete Page
Const Word_addr = 5                     ' verwendete Speicherzelle
Const Esc = 27

Dim Slave_wa As Byte                    ' Slave Write Adresse
Dim Ee_data As Byte                     ' verwendetes Datenbyte
Dim Temp As Byte

Config Scl = Portb.0                    ' PB0 ist SCL
Config Sda = Portb.1                    ' PB1 ist SDA
'Config I2cdelay = 10                    ' SCL = 100 kHz

Declare Sub I2c_wb(byval Swa As Byte , Byval Wa As Byte , Dta As Byte)
Declare Function I2c_rb(byval Swa As Byte , Byval Wa As Byte) As Byte

Slave_wa = Device_id                    ' Berechnung der Slaveadresse
Shift Slave_wa , Left , 4

Temp = Page_addr
Shift Temp , Left

Slave_wa = Slave_wa Or Temp             ' Berechnung Slave Write Adresse

Print "EEPROM Schreiben & Lesen - Abbruch mit ESC"
Ee_data = &HA5

Do
   Incr Ee_data                         ' Inkrementieren Datenbyte
   Print "Schreibe " ; Ee_data ; " nach Adresse " ; Word_addr
   I2c_wb Slave_wa , Word_addr , Ee_data       ' Byte in EEPROM schreiben

   Temp = I2c_rb(slave_wa , Word_addr)  ' Byte aus EEPROM zurcklesen
   Print "Lese " ; Temp ; " von Adresse " ; Word_addr       ' Ausgabe gelesenes Byte
   Wait 1
   Temp = Inkey()
Loop Until Temp = Esc

Print "Ende."

End

Sub I2c_wb(byval Swa As Byte , Byval Wa As Byte , Dta As Byte)
   I2cstart                             ' I2C Write Sequence
   I2cwbyte Swa
   I2cwbyte Wa
   I2cwbyte Dta
   I2cstop
   Waitms 10                            ' Warten auf Ende des Schreibzyklus
End Sub

Function I2c_rb(byval Swa As Byte , Byval Wa As Byte) As Byte
   Local T As Byte
   Local Sra As Byte

   Sra = Swa Or 1

   I2cstart                             ' I2C Read Sequence
   I2cwbyte Swa
   I2cwbyte Wa
   I2cstart
   I2cwbyte Sra
   I2crbyte T , Nack
   I2cstop
   I2c_rb = T
End Function
