'----------------------------------------------------------------------------------------
'name                     : RGB_LED.bas
'programmed by            : Claus Kuhnel
'date                     : 2008-12-29
'purpose                  : Controlling a RGB LED
'micro                    : LilyPad Arduino - ATmega168
'tested with              : V.1.12.0.0 (2010-08-08)
'suited for demo          : yes
'commercial addon needed  : no
'----------------------------------------------------------------------------------------
$regfile = "m168def.dat"
$crystal = 8000000
$baud = 19200

$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 20                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space

Debug On                                                    ' for debug output on, otherwise off

Config Portb = Output
Portb = 0

Rled Alias Portb.0
Gled Alias Portb.1
Bled Alias Portb.2

Dim Count As Byte
Dim Rvalue As Byte : Rvalue = 0
Dim Gvalue As Byte : Gvalue = 0
Dim Bvalue As Byte : Bvalue = 0
Dim Idx As Byte


Config Timer0 = Timer , Prescale = 1                        ' 8 MHz Clock
Start Timer0
On Ovf0 Tick                                                ' Timer periode 256 / 8 MHz = 32 us
Enable Ovf0
Enable Interrupts

Do
   Idx = 0
   Do
      If Idx = 0 Then
         Restore Rgb
      End If
      Read Rvalue : Debug Rvalue
      Read Gvalue : Debug Gvalue
      Read Bvalue : Debug Bvalue
      Waitms 100
      Incr Idx
   Loop Until Idx >= 28
Loop
End

Tick:
   If Count >= Rvalue Then
      Set Rled
   Else
      Reset Rled
   End If
   If Count >= Gvalue Then
      Set Gled
   Else
      Reset Gled
   End If
   If Count >= Bvalue Then
      Set Bled
   Else
      Reset Bled
   End If
   Incr Count
Return

Rgb:
Data 0 , 0 , 0 , 64 , 0 , 0 , 128 , 0 , 0 , 192 , 0 , 0
Data 192 , 0 , 0 , 128 , 64 , 0 , 64 , 128 , 0 , 0 , 192 , 0
Data 0 , 192 , 0 , 0 , 128 , 64 , 0 , 64 , 128 , 0 , 0 , 192
Data 0 , 0 , 192 , 64 , 0 , 128 , 128 , 0 , 64 , 192 , 0 , 0
Data 192 , 0 , 0 , 128 , 64 , 0 , 64 , 128 , 0 , 0 , 192 , 0
Data 0 , 192 , 0 , 0 , 128 , 64 , 0 , 64 , 128 , 0 , 0 , 192
Data 0 , 0 , 192 , 0 , 0 , 128 , 0 , 0 , 64 , 0 , 0 , 0