'------------------------------------------------------------------------------------
'name                     : adc1s.bas
'programmed by            : Claus Kuhnel
'date                     : 2008-12-28
'purpose                  : Single-ended AD conversion using int. reference voltage
'micro                    : ATmega32
'tested with              : V.1.12.0.0 (2010-08-08)
'suited for demo          : yes
'commercial addon needed  : no
'------------------------------------------------------------------------------------
$regfile = "m32def.dat"
$crystal = 14745600
$baud = 19200

$include "init_staver24.bas"

Const Bandgap = &B11110                                     ' MUX address for bandgap

Dim Result As Word
Dim Voltage As Single
Dim Reference As Single
Dim S As String * 10

Config Adc = Single , Prescaler = Auto , Reference = Avcc

Reference = 5.0                                             ' Reference voltage is AVCC

Start Adc

Do
  Result = Getadc(bandgap)
  Print "ADC  = " ; Hex(result) ; Spc(3);

  Voltage = Result * Reference
  Voltage = Voltage / 1024

  S = Fusing(voltage , " #.###")
  Print "Vref = " ; S ; " V"

  Waitms 500
Loop

End