'-------------------------------------------------------------------------
' iButton DS1994 Speicheroperationen
'-------------------------------------------------------------------------
$regfile = "m8def.dat"                                      ' ATmega8
$crystal = 3690000                                          ' fr STK500
$baud = 9600

Config 1wire = Portb.0                                      ' PB0 ist 1-Wire Busleitung

Const Ctargetaddr = &H0179                                  ' Zieladresse

Const Skiprom = &HCC                                        ' berspringe ROM Kommandos
Const Writescratch = &H0F                                   ' Schreibe Scratchpad RAM
Const Readscratch = &HAA                                    ' Lese Scratchpad RAM
Const Copyscratch = &H55                                    ' Kopiere Scratchpad in NVRAM
Const Readmemory = &HF0                                     ' Lese NVRAM

Dim Targetaddr As Word At &H60                              ' Zieladresse
Dim Ta2 As Byte At &H61 Overlay
Dim Ta1 As Byte At &H60 Overlay
Dim Ea As Byte

Dim Temp(8) As Byte                                         ' Temporrer Speicher

Dim I As Byte                                               ' Index

Print
Print "DS1994 Speicheroperationen"
Print "Daten im Array: ";
For I = 1 To 8
   Temp(i) = I + &H30                                       ' Initialisiere Array
   Print Hex(temp(i)) ; " ";
Next
Print
Targetaddr = Ctargetaddr
Print "TA:   " ; Hex(targetaddr)
Print

Print "Kopiere Array ins ScratchPad RAM..."
1wreset                                                     ' Reset iButton
If Err = 1 Then Print "iButton ERROR"
1wwrite Skiprom
1wwrite Writescratch                                        ' Schreibe ins Scratchpad RAM
1wwrite Ta1
1wwrite Ta2
For I = 1 To 8
   1wwrite Temp(i)
Next
Print

Print "Loesche Array..."
Print "Daten im Array: ";
For I = 1 To 8
   Temp(i) = &H96                                           ' Lsche Array
   Print Hex(temp(i)) ; " ";
Next
Print
Print

Print "Lese ScratchPad RAM..."
1wreset                                                     ' Reset iButton
If Err = 1 Then Print "iButton ERROR"
1wwrite Skiprom
1wwrite Readscratch                                         ' Lese Scratchpad RAM
Ta1 = 1wread()
Ta2 = 1wread()
Ea = 1wread()
Print "Gelesene Daten: ";
For I = 1 To 8
   Temp(i) = 1wread()
   Print Hex(temp(i)) ; " ";                                ' Lese Array
Next
Print
Print "TA:   " ; Hex(targetaddr)
Print "EA:   " ; Hex(ea)
Print

Print "Loesche Array..."
Print "Daten im Array: ";
For I = 1 To 8
   Temp(i) = &H96                                           ' Lsche Array erneut
   Print Hex(temp(i)) ; " ";
Next
Print
Print

Print "Kopiere Scratchpad RAM ins NVRAM..."
1wreset                                                     ' Reset iButton
If Err = 1 Then Print "iButton ERROR"
1wwrite Skiprom
1wwrite Copyscratch                                         ' Kopiere ins NVRAM
1wwrite Ta1
1wwrite Ta2
1wwrite Ea
Print

Print "Lese NVRAM..."
1wreset                                                     ' Reset iButton
If Err = 1 Then Print "iButton ERROR"
1wwrite Skiprom
1wwrite Readmemory                                          ' Lese NVRAM
1wwrite Ta1
1wwrite Ta2
Print "Gelesene Daten: ";
For I = 1 To 8
   Temp(i) = 1wread()
   Print Hex(temp(i)) ; " ";                                ' Lese Array
Next
Print
Print "TA:   " ; Hex(targetaddr)

End




