'-------------------------------------------------------------------------
' iButton DS1994 Timeroperationen
'-------------------------------------------------------------------------
$regfile = "m8def.dat"                                      ' ATmega8
$crystal = 3690000                                          ' fr STK500
$baud = 9600

Config 1wire = Portb.0                                      ' PB0 ist 1-Wire Busleitung

Const Ctargetaddr = &H0179                                  ' Zieladresse

Const Skiprom = &HCC                                        ' berspringe ROM Kommandos
Const Writescratch = &H0F                                   ' Schreibe Scratchpad RAM
Const Readscratch = &HAA                                    ' Lese Scratchpad RAM
Const Copyscratch = &H55                                    ' Kopiere Scratchpad in NVRAM
Const Readmemory = &HF0                                     ' Lese NVRAM

Const Controlreg = &H0201                                   'Timer Control Register
Const Rtcreg = &H0202                                       'RTC Register   $0202-$0206
Const Intervreg = &H0207                                    'IntervallTimer $0207-$020B

Const Starttimer = &B00010000                               'Start IntervalTimer
Const Stoptimer = &B01010000                                'Stopp IntervalTimer

Dim Targetaddr As Word At &H60                              ' Zieladresse
Dim Ta2 As Byte At &H61 Overlay
Dim Ta1 As Byte At &H60 Overlay
Dim Ea As Byte
Dim Targetcont As Byte

Dim Temp(8) As Byte                                         ' Temporrer Speicher

Dim I As Byte                                               ' Index

Declare Sub Writeds1994reg()
Declare Sub Readds1994timer()
Declare Sub Displaytimer()

Print
Print "DS1994 Timeroperationen"
Print "Starte Intervalltimer"
Targetaddr = Controlreg                                     ' Start des IntervalTimers
Targetcont = Starttimer
Gosub Writeds1994reg

Print "TA:   " ; Hex(targetaddr) ; Spc(3);
Print "Data: " ; Hex(targetcont)

Targetaddr = Intervreg                                      ' Lese IntervalTimer
Gosub Readds1994timer
Gosub Displaytimer

Targetaddr = Rtcreg                                         ' Lese RTC
Gosub Readds1994timer
Gosub Displaytimer

Print "Pause 2 s" : Wait 2                                  ' Warte 2 s

Targetaddr = Intervreg                                      ' Lese IntervalTimer
Gosub Readds1994timer
Gosub Displaytimer

Targetaddr = Rtcreg                                         ' Lese RTC
Gosub Readds1994timer
Gosub Displaytimer

Print
Print "Stoppe Intervalltimer"
Targetaddr = Controlreg                                     'Stopp IntervalTimer
Targetcont = Stoptimer
Gosub Writeds1994reg

Print "TA:   " ; Hex(targetaddr) ; Spc(3);
Print "Data: " ; Hex(targetcont)

Targetaddr = Intervreg                                      ' Lese IntervalTimer
Gosub Readds1994timer
Gosub Displaytimer

Targetaddr = Rtcreg                                         ' Lese RTC
Gosub Readds1994timer
Gosub Displaytimer

Print "Pause 2 s" : Wait 2                                  ' Warte 2 s

Targetaddr = Intervreg                                      ' Lese IntervalTimer
Gosub Readds1994timer
Gosub Displaytimer

Targetaddr = Rtcreg                                         ' Lese RTC
Gosub Readds1994timer
Gosub Displaytimer

End


Sub Writeds1994reg()
   1wreset                                                  ' Reset iButton
   If Err = 1 Then Print "iButton ERROR"
   1wwrite Skiprom
   1wwrite Writescratch                                     ' Schreibe ins Scratchpad RAM
   1wwrite Ta1
   1wwrite Ta2
   1wwrite Targetcont

   1wreset                                                  ' Reset iButton
   If Err = 1 Then Print "iButton ERROR"
   1wwrite Skiprom
   1wwrite Readscratch                                      ' Lese Scratchpad RAM
   Ta1 = 1wread()
   Ta2 = 1wread()
   Ea = 1wread()
   Targetcont = 1wread()

   1wreset                                                  ' Reset iButton
   If Err = 1 Then Print "iButton ERROR"
   1wwrite Skiprom
   1wwrite Copyscratch                                      ' Kopiere ins NVRAM
   1wwrite Ta1
   1wwrite Ta2
   1wwrite Ea
End Sub

Sub Readds1994timer()
   1wreset                                                  ' Reset iButton
   If Err = 1 Then Print "iButton ERROR"
   1wwrite Skiprom
   1wwrite Readmemory                                       ' Lese NVRAM
   1wwrite Ta1
   1wwrite Ta2
   For I = 1 To 5
      Temp(i) = 1wread()
   Next
End Sub

Sub Displaytimer()
   Print "TA:   " ; Hex(targetaddr) ; Spc(3);
   Print "Timer = " ;
   For I = 4 To 1 Step -1
      Print Hex(temp(i));
   Next
   Print
End Sub