'############################################################################################
' Program sample for demonstration of opening screen and text message
' Goldengate.bas
' Display D072
' Claus Khnel 2007-04-06
'############################################################################################

$hwstack = 64
$swstack = 128
$framesize = 16
'you might need to raise these numbers if your code grows

$regfile = "m128def.dat"
$crystal = 8000000                                          'enter the used clock of your actual microcontroller

'############################################################################################
'Application variables
Dim Txt$ As String * 20

'############################################################################################
'Definition of used ports and pull up resistors
                                                            'At our boards we are using Port B for the SPI-communication to the LCD.
                                                            'Now we need to select Port B as to an output port (data output to the display)
Ddrb = &B01110110                                           'DDR = Data direction register; Port B1, B2, B4, B5, B6 switched to output (1) as needed by the display ....
Portb = &B10001001                                          '... the other ports of Port B are inputs with switched on pull up resistors

Ddra = &B00000000                                           'switch all 8 Ports of Port A to input (0), Pin (PA.0 - PA.7)
Porta = &B11111111                                          'All port pins have individually selectable pull-up resistors. Here we enable these pull-up-resisitors, so these Pins are always at logical 1
                                                            'You need to pull these Pins against ground (GND)
Ddrc = &B00000000                                           'switch all Ports of Port C to input
Portc = &B11111111                                          'all pull-up-Resistors turned on

Ddrd = &B00000000                                           'switch all Ports of Port D to input
Portd = &B11111111                                          'all pull-up-Resistors turned on

Ddre = &B00000000                                           'switch all Ports of Port E to input
Porte = &B11111111                                          'all pull-up-Resistors turned on

Ddrf = &B00000000                                           'switch all Ports of Port F to input
Portf = &B11111111                                          'all pull-up-Resistors turned on

Ddrg = &B00000000                                           'switch all Ports of Port G to input
Portg = &B11111111                                          'all pull-up-Resistors turned on

$include "C:\Programme\Bascom-avr\Mysamples\Displaysamples\Includes\Init21_display3000.bas"

'############################################################################################
'Initialisation of the display (needs to be done only for changes from default)
Orientation = Portrait180                                   'select neeeded orientation, here: Portrait180 mode
Graphics_mode = 65k_compressed                              'select the needed color mode, here 65.536 colors
Gosub Lcd_init                                              'Initialisation routine of the display, Needs to be done only once at the beginning
Gosub Lcd_cls

'############################################################################################
'Main program
Do
   Restore T2a
   Call Lcd_bitmap(0 , 0 , 131 , 175)
   Wait 2

   Call Lcd_box(0 , 0 , 131 , 175 , Bright_yellow)
   Txt$ = "Visit"
   Call Lcd_print(txt$ , 10 , 70 , 2 , 1 , 2 , Blue , Bright_yellow)
   Txt$ = "Golden Gate"
   Call Lcd_print(txt$ , 10 , 100 , 2 , 1 , 2 , Blue , Bright_yellow)
   Wait 1
   Txt$ = "Visit"
   Call Lcd_print(txt$ , 10 , 70 , 2 , 1 , 2 , Bright_yellow , Bright_yellow)
   Txt$ = "Golden Gate"
   Call Lcd_print(txt$ , 10 , 100 , 2 , 1 , 2 , Bright_yellow , Bright_yellow)
Loop

End
'############################################################################################

$include "C:\Programme\Bascom-avr\Mysamples\Displaysamples\Includes\Glcd21_display3000.bas"

'--------------------------------------------------------------------------------------------
' Includes agraphics file shown at start up - you need to change the directory.
'--------------------------------------------------------------------------------------------
$inc T2a , Nosize , "C:\Programme\BASCOM-AVR\mySamples\Display3000\Grafik\Goldengate.bin"

'############################################################################################
$include "C:\Programme\Bascom-avr\Mysamples\Displaysamples\Includes\Glcd21_fonts.bas"
'Dummy Data um Fehlermeldungen bei der Kompilierung der Standardroutinen zu vermeiden
'Die Tabelle wird dann bei Nutzung eines indizierten Grafikdatei mit "echten" Daten ausgetauscht
Colortable:
Data 0