'------------------------------------------------------------------------------------
'name                     : myTWI_Temperatursensor_Test.bas
'programmed by            : Claus Kuhnel
'date                     : 2009-02-07
'purpose                  : Test for myTWI Temperatursensor & mySmartControl M168
'micro                    : ATmega168
'tested with              : V.1.12.0.0 (2010-08-08)
'suited for demo          : yes
'commercial addon needed  : no
'------------------------------------------------------------------------------------
$regfile = "m168def.dat"
$crystal = 20000000                          ' used crystal frequency
$baud = 9600                                 ' used baud rate

$hwstack = 32                                ' default use 32 for the hardware stack
$swstack = 10                               ' default use 10 for the SW stack
$framesize = 40                      ' default use 40 for the frame space

Debug On                                     ' On

Config Scl = Portc.5                        ' PC5 is SCL on myTWI Temperatursensor
Config Sda = Portc.4                         ' PC4 is SDA on myTWI Temperatursensor
Config I2cdelay = 10                         ' SCL = 100 kHz

' myAVR LCD Configuration
Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cursor Off

Const Device_id = &H9                        ' Device ID for LM75
Const Esc = 27

Dim Slave_wa As Byte                         ' Slave Write Adresse
Dim Temp As Byte
Dim Temperature As Word
Dim Ti As Integer
Dim Ts As Single

Declare Function I2c_read_temperature(byval Swa As Byte) As Word

Slave_wa = Device_id                         ' Berechnung der Slaveadresse
Shift Slave_wa , Left , 4

Debug "Read Temperature from myTWI Temperature Sensor - Quit by ESC"
Debug "Slave Write Address is 0x" ; Hex(slave_wa)

Cls
Lcd "Temperature is"

Do
   Temperature = I2c_read_temperature(slave_wa)   ' Read temperature from LM75
   Debug "Temperature Value is 0x" ; Hex(temperature)
   Shift Temperature , Right , 7

   Debug "Temperature in 0.5 grd steps is 0x" ; Hex(temperature)
   Ti = Temperature
   If Ti > &HFF Then
      Ti = Ti Or $ff00
   End If
   Ts = Ti / 2.
   Debug "Temperature is " ; Ts ; " grd C"
   Lowerline : Lcd "                "
   Lowerline : Lcd Ts ; " grd C"
   Wait 1
   Temp = Inkey()
Loop Until Temp = Esc

Print "End"
End

Function I2c_read_temperature(byval Swa As Byte) As Word
   Local Sra As Byte
   Local Thi As Byte , Tlo As Byte
   Local T As Word

   Sra = Swa Or 1

   I2cstart
   I2cwbyte Sra
   I2crbyte Thi , Ack
   I2crbyte Tlo , Nack
   I2cstop

   T = Thi
   Shift T , Left , 8
   T = T + Tlo
   I2c_read_temperature = T
End Function