'############################################################################################
' Program sample demonstrating plotting measuring data (simulated by pseudo-random numbers)
' Display D072
' Claus Khnel 2007-04-03
'############################################################################################

$hwstack = 64
$swstack = 128
$framesize = 16                                             'you might need to raise these numbers if your code grows !!!!!!! (unexpected behaviour of the program often results of too small stacks)

$regfile = "m128def.dat"
$crystal = 14745600                                         'enter the used clock of your actual microcontroller

'############################################################################################
'Application variables
Dim Idx As Byte
Dim Tmpx As Byte , Tmpy As Byte , Tmpxold As Byte , Tmpyold As Byte
Dim Value(128) As Byte
Dim Filtered_value(128) As Byte
Dim Mean As Word
Dim Txt$ As String * 20
Const Filter = 5

'############################################################################################
'Definition of used ports and pull up resistors
                                                            'At our boards we are using Port B for the SPI-communication to the LCD.
                                                            'Now we need to select Port B as to an output port (data output to the display)
Ddrb = &B01110110                                           'DDR = Data direction register; Port B1, B2, B4, B5, B6 switched to output (1) as needed by the display ....
Portb = &B10001001                                          '... the other ports of Port B are inputs with switched on pull up resistors

Ddra = &B00000000                                           'switch all 8 Ports of Port A to input (0), Pin (PA.0 - PA.7)
Porta = &B11111111                                          'All port pins have individually selectable pull-up resistors. Here we enable these pull-up-resisitors, so these Pins are always at logical 1
                                                            'You need to pull these Pins against ground (GND)
Ddrc = &B00000000                                           'switch all Ports of Port C to input
Portc = &B11111111                                          'all pull-up-Resistors turned on

Ddrd = &B00000000                                           'switch all Ports of Port D to input
Portd = &B11111111                                          'all pull-up-Resistors turned on

Ddre = &B00000000                                           'switch all Ports of Port E to input
Porte = &B11111111                                          'all pull-up-Resistors turned on

Ddrf = &B00000000                                           'switch all Ports of Port F to input
Portf = &B11111111                                          'all pull-up-Resistors turned on

Ddrg = &B00000000                                           'switch all Ports of Port G to input
Portg = &B11111111                                          'all pull-up-Resistors turned on

$include "C:\Programme\Bascom-avr\Mysamples\Displaysamples\Includes\Init21_display3000.bas"

'############################################################################################
'Initialisation of the display (needs to be done only for changes from default)
Orientation = Portrait180                                   'landscape mode
Graphics_mode = 65k_compressed                              'select the needed color mode, here 65.536 colors
Gosub Lcd_init
Gosub Lcd_cls                                               'clear screen (White)

'############################################################################################
'Main program
' Print text
Txt$ = "Load array..."
Call Lcd_print(txt$ , 2 , 2 , 1 , 1 , 1 , White , Dark_blue)
Wait 2
Call Lcd_print(txt$ , 2 , 2 , 1 , 1 , 1 , White , White)

For Idx = 1 To 128
   Value(idx) = Rnd(128)                                    ' random value is limited to byte by argument 128
   Filtered_value(idx) = 0
Next

For Idx = 1 To 123
   Mean = Value(idx)
   Mean = Mean + Value(idx + 1)
   Mean = Mean + Value(idx + 2)
   Mean = Mean + Value(idx + 3)
   Mean = Mean + Value(idx + 4)
   Mean = Mean \ 5
   Filtered_value(idx) = Low(mean)
Next

Do
   Gosub Lcd_cls                                            'clear screen (White)

   ' Draw frame
   Call Lcd_rect(2 , 12 , 129 , 139 , 0 , Black)

   ' Print text
   Txt$ = "Show original data"
   Call Lcd_print(txt$ , 2 , 2 , 1 , 1 , 1 , White , Dark_blue)

   ' Draw line in frame
   Tmpxold = 2 : Tmpyold = 129
   For Idx = 1 To 128
      Tmpx = Idx + 1
      Tmpy = 139 - Value(idx)
      Call Lcd_draw(tmpxold , Tmpyold , Tmpx , Tmpy , 0 , Red)
      Tmpxold = Tmpx
      Tmpyold = Tmpy
'      Waitms 100
   Next
   Wait 2
   ' Clear text
   Call Lcd_print(txt$ , 2 , 2 , 1 , 1 , 1 , White , White)

   ' Print text
   Txt$ = "Add filtered data"
   Call Lcd_print(txt$ , 2 , 2 , 1 , 1 , 1 , White , Dark_blue)

   ' Draw line in frame
   Tmpxold = 2 : Tmpyold = 129
   For Idx = 1 To 128
      Tmpx = Idx + 1
      Tmpy = 139 - Filtered_value(idx)
      Call Lcd_draw(tmpxold , Tmpyold , Tmpx , Tmpy , 0 , Blue)
      Tmpxold = Tmpx
      Tmpyold = Tmpy
'      Waitms 100
   Next
   Wait 2

   ' Clear text
   Call Lcd_print(txt$ , 2 , 2 , 1 , 1 , 1 , White , White)
Loop

End

'############################################################################################

$include "C:\Programme\Bascom-avr\Mysamples\Displaysamples\Includes\Glcd21_display3000.bas"

'--------------------------------------------------------------------------------------------
' Includes agraphics file shown at start up - you need to change the directory.
'--------------------------------------------------------------------------------------------
'$inc T2a , Nosize , "C:\Programme\BASCOM-AVR\mySamples\Display3000\Grafik\Goldengate.bin"

'############################################################################################
$include "C:\Programme\Bascom-avr\Mysamples\Displaysamples\Includes\Glcd21_fonts.bas"
'Dummy Data um Fehlermeldungen bei der Kompilierung der Standardroutinen zu vermeiden
'Die Tabelle wird dann bei Nutzung eines indizierten Grafikdatei mit "echten" Daten ausgetauscht
Colortable:
Data 0