$regfile = "m8def.dat"                                      ' ATmega8
$crystal = 3686400                                          ' fr STK500
$baud = 19200

Declare Function Lopulse() As Byte

Dim Value As Byte

Config Pinb.0 = Input                                       ' PB0 ist Eingang
Set Portb.0.0

Config Timer0 = Timer , Prescale = 1

On Timer0 Overflow_isr Nosave

Enable Timer0
Enable Interrupts

Do
   Print "Waiting for pulse..."
   Value = Lopulse()
   Print "Measured Pulse = " ; Value
Loop

End

Function Lopulse() As Byte
   $asm
   Hilo:
   Sbic pinb,0                                              ' warte auf Hi-Lo an PB0
   Rjmp Hilo
   $end Asm
   Tcnt0 = 0                                                ' Reset Timer0
   Start Timer0
   $asm
   Lohi:
   Sbis pinb,0                                              ' warte auf Lo-Hi on PB0
   Rjmp Lohi
   $end Asm
   Stop Timer0                                              ' Stop Timer0 nach minmal 10 Zyklen
   Lopulse = Tcnt0
End Function

' Overflow_ISR stoppt Timer0 und setzt TCNT0 zu Null (Timeout)
Overflow_isr:
   !push R24
   Stop Timer0
   Tcnt0 = 0
   !pop R24
Return