'------------------------------------------------------------------------------------
'name : servo1.bas
'programmed by : Claus Kuhnel
'date : 2009-02-25
'purpose : Servo Control by Orangutan SV-168
'micro : ATmega168
'tested with : V.1.11.9.3
'suited for demo : yes
'commercial addon needed : no
'------------------------------------------------------------------------------------
$regfile = "m168def.dat"                                    ' Set the chip as a Mega 168
$crystal = 20000000                                         ' Clock speed 20 MHZ

$include "orangutan.def" ' include definitions and declarations for Orangutan-SV168
$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space

Dim Pulse As Byte

Config Servos = 1 , Servo1 = Portd.0 , Reload = 10

Enable Interrupts

Cls : Lcd "Servo"

Do
   Call Beep(100) : Pulse = 50
   Locate 2 , 1 : Lcd " "
   Locate 2 , 1 : Lcd Pulse
   Servo(1) = Pulse
   Wait 2
   Pulse = 0
   Locate 2 , 1 : Lcd " "
   Locate 2 , 1 : Lcd Pulse
   Servo(1) = Pulse
   Wait 2
   Pulse = 100
   Locate 2 , 1 : Lcd " "
   Locate 2 , 1 : Lcd Pulse
   Servo(1) = Pulse
   Wait 2
Loop

End

$include "orangutan.bas"                                    ' include subroutines and functions for Orangutan-SV168
