'------------------------------------------------------------------------------------
'name : servo2.bas
'programmed by : Claus Kuhnel
'date : 2009-03-09
'purpose : setservo Control by Orangutan SV-168
'micro : ATmega168
'tested with : V.1.11.9.3
'suited for demo : yes
'commercial addon needed : no
'------------------------------------------------------------------------------------
$regfile = "m168def.dat"
$crystal = 20000000                                         ' used crystal frequency

$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space

Declare Sub Setservo(byval X As Byte)

Const Direct = 0

Dim Reload As Word : Reload = 50000                         ' Periode = 20 ms
Dim Pulse As Word : Pulse = 3100                            ' middle position = 1.5 ms

Config Portd = Output
Grn_led Alias Portd.7                                       ' Green User LED
Red_led Alias Portd.1                                       ' Red User LED
Servo_ Alias Portd.0                                        ' connect servo to PD0

Red_led = 0
Grn_led = 0

Icr1h = High(reload)
Icr1l = Low(reload)                                         ' Reload Timer1 for a Period of 20 ms
Ocr1ah = High(pulse)
Ocr1al = Low(pulse)
Tccr1a = &B00000010
Tccr1b = &B00011010

On Ovf1 Ovf1_isr                                            ' Sprung zur Timer1_ISR
On Oc1a Oc1a_isr

Enable Ovf1                                                 ' Enable Timer1 Overflow Interrupt
Enable Oc1a
Enable Interrupts                                           ' Enable Global Interrupt

Do
#if Direct
   Toggle Red_led
   Pulse = 3100                                             ' middle position
   Wait 2
   Toggle Red_led
   Pulse = 500                                              ' left position
   Wait 2
   Toggle Red_led
   Pulse = 5600                                             ' right position
   Wait 2
#else
   Toggle Red_led
   Setservo 50
   Wait 2
   Toggle Red_led
   Setservo 0
   Wait 2
   Toggle Red_led
   Setservo 100
   Wait 2
#endif
Loop

End

Ovf1_isr:
   Toggle Grn_led
   Servo_ = 1
   Ocr1ah = High(pulse)
   Ocr1al = Low(pulse)
Return

Oc1a_isr:
   Servo_ = 0
Return

Sub Setservo(byval X As Byte)
   Local Y As Byte
   If X > 100 Then
      Y = 100
   Else
      Y = X
   End If
   Pulse = 51 * Y
   Pulse = Pulse + 500
End Sub